<?php
/*
Plugin Name: blogintroduction
Plugin URI: http://blog.huebel-online.de/blogintroduction-wordpress-widget/
Description: Shows a thumbnail of a blogroll/linkroll-entry by random
Author: Kim Huebel
Version: 0.1.1
Author URI: http://blog.huebel-online.de
*/

function widget_blogintroduction_init() {

        if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
                return;

        function widget_blogintroduction_control() {

                $options = $newoptions = get_option('widget_blogintroduction');
                if ( $_POST['blogintroduction-submit'] ) {
                        $newoptions['title'] = strip_tags(stripslashes($_POST['blogintroduction-title']));
                        $newoptions['websnaprapikey'] = strip_tags(stripslashes($_POST['blogintroduction-websnaprapikey']));
                        $newoptions['width'] = strip_tags(stripslashes($_POST['blogintroduction-width']));
                        $newoptions['category'] = strip_tags(stripslashes($_POST['blogintroduction-category']));
                        $newoptions['target'] = strip_tags(stripslashes($_POST['blogintroduction-target']));
                        $newoptions['showdescription'] = strip_tags(stripslashes($_POST['blogintroduction-showdescription']));
                        $newoptions['showinvisible'] = strip_tags(stripslashes($_POST['blogintroduction-showinvisible']));
                        $newoptions['refreshviaAjax'] = strip_tags(stripslashes($_POST['blogintroduction-refreshviaAjax']));
                        $newoptions['refreshAfter'] = strip_tags(stripslashes($_POST['blogintroduction-refreshAfter']));

                }

                if ( $options != $newoptions ) {
                        $options = $newoptions;
                        update_option('widget_blogintroduction', $options);
                }

                // initialize options
                if ($options['title']=="") {
                        $options['title'] = "Blogvorstellung";
                }
                if ($options['width']=="") {
                        $options['width'] = "170";
                }
                if ($options['category']=="") {
                        $options['category'] = "all";
                }
                if ($options['target']=="") {
                        $options['target'] = "_top";
                }

        ?>

<p style="text-align:left"><label for="blogintroduction-title"><?php _e('Titel:', 'widgets'); ?> <br/><input style="width: 250px;" id="blogintroduction-title" name="blogintroduction-title" value="<?php echo wp_specialchars($options['title'], true); ?>" type="text"></label></p>
<p style="text-align:left"><label for="blogintroduction-websnaprapikey"><?php _e('<a href="http://www.websnapr.com" target="_new">Websnapr</a>-API-Key:', 'widgets'); ?> <br/><input style="width: 250px;" id="blogintroduction-websnaprapikey" name="blogintroduction-websnaprapikey" value="<?php echo wp_specialchars($options['websnaprapikey'], true); ?>" type="text"></label></p>
<p style="text-align:left"><label for="blogintroduction-width"><?php _e('Bild-Breite:', 'widgets'); ?> <br/><input style="width: 250px;" id="blogintroduction-width" name="blogintroduction-width" value="<?php echo wp_specialchars($options['width'], true); ?>" type="text"></label></p>
<p style="text-align:left"><label for="blogintroduction-category"><?php _e('Link-Kategorie:', 'widgets'); ?> <br/>
<?php
                 $categories = get_terms('link_category', "hide_empty=1");
                 $select_cat = "<select id=\"blogintroduction-category\" name=\"blogintroduction-category\">\n";
                 $cat_id = $options['category'];
                 $select_cat .= '<option value="all"'  . (($cat_id == 'all') ? " selected='selected'" : '') . '>' . __('View all Categories') . "</option>\n";
                 foreach ((array) $categories as $cat)
                         $select_cat .= '<option value="' . $cat->term_id . '"' . (($cat->term_id == $cat_id) ? " selected='selected'" : '') . '>' . sanitize_term_field('name', $cat->name, $cat->term_id, 'link_category', 'display') . "</option>\n";
                 $select_cat .= "</select>\n";
                 echo $select_cat;
?>
</label></p>
<p style="text-align:left"><label for="blogintroduction-target"><?php _e('Link-Ziel:', 'widgets'); ?> <br/>
<?php
                 $select_target = "<select id=\"blogintroduction-target\" name=\"blogintroduction-target\">\n";
                 $cat_id = $options['target'];
                 $select_target .= '<option value="_top"'  . (($cat_id == '_top') ? " selected='selected'" : '') . '>Im aktuellen Fenster</option>\n';
                 $select_target .= '<option value="_new"'  . (($cat_id == '_new') ? " selected='selected'" : '') . '>Im neuen Fenster</option>\n';
                 $select_target .= "</select>\n";
                 echo $select_target;
?>
</label></p>
<?php
echo '<p style="text-align:left"><label for="blogintroduction-showdescription"> '. _e('Beschreibung anzeigen:', 'widgets') .' <input title="Haken setzen zur Anzeige" style="width: 15px;" id="blogintroduction-showdescription" name="blogintroduction-showdescription" type="checkbox" value="1" '.(($options['showdescription']==0)?'':'checked').' /></label></p>';
echo '<p style="text-align:left"><label for="blogintroduction-showinvisible"> '. _e('Unsichtbare Links anzeigen:', 'widgets') .' <input title="Haken setzen zur Anzeige" style="width: 15px;" id="blogintroduction-showdescription" name="blogintroduction-showinvisible" type="checkbox" value="1" '.(($options['showinvisible']==0)?'':'checked').' /></label></p>';
echo '<p style="text-align:left"><label for="blogintroduction-refreshviaAjax"> '. _e('Neuer Thumb per Ajax in Sekunden:', 'widgets') .'  <br/><input title="Haken setzen, um das Neuladen per Ajax zu aktivieren" style="width: 15px;" id="blogintroduction-refreshviaAjax" name="blogintroduction-refreshviaAjax" type="checkbox" value="1" '.(($options['refreshviaAjax']==0)?'':'checked').' /></label><label for="blogintroduction-refreshAfter"><input title="Hier die Sekunden eingeben, nach denen ein neuer Thumb geladen werden soll" style="width: 50px;" id="blogintroduction-refreshAfter" name="blogintroduction-refreshAfter" value="'.wp_specialchars($options['refreshAfter'], true).'" type="text"></label></p>';

?>

<input type="hidden" name="blogintroduction-submit" id="delicious-submit" value="1" />

<?php
        }

        // This prints the widget
        function widget_blogintroduction($args) {
                extract($args);
                $options = (array) get_option('widget_blogintroduction');

                // Default-values, only be used, if running in totally unconfigured mode. Should never be happen, I think
                if ($options['title']=="") {
                        $options['title'] = "Blogvorstellung";
                }
                 if ($options['category']=="") {
                        $options['category'] = "56";
                }
                if ($options['width']=="") {
                        $options['width'] = "170";
                }
                if ($options['target']=="") {
                        $options['target'] = "_top";
                }

                echo $before_widget . $before_title . $options['title'] . $after_title;
?>
<ul>
<?php
                 $cat_id = $options['category'];
                 if ( 'all' == $cat_id )
                         $cat_id = '';

                 $hide_invisible = 1;
                 if ($options['showinvisible']!="") {
                         $hide_invisible = 0;
                 }

                 $args = array('category' => $cat_id, 'hide_invisible' => $hide_invisible, 'orderby' => 'id', 'hide_empty' => 1);
                 $links = get_bookmarks( $args );

                 // find the link to show by random
                 srand(microtime()*1000000);
                 $linkelement = rand(0,sizeof($links)-1);
                 $link = $links[$linkelement];
                 $link = sanitize_bookmark($link);
                 $link->link_name = attribute_escape($link->link_name);
                 $enc_url = urlencode($link->link_url);

                 // building the link
                 echo'<div id="wp-blogintroduction-link"><a class="wp-blogintroduction" href="'.$link->link_url.'" title="'.$link->link_name.'" target="'.$options['target'].'"><img class="wp-blogintroduction" src="http://images.websnapr.com/?url='.$enc_url.'/&size=s';
                 if ($options['websnaprapikey']!="") {
                         echo '&key='.$options['websnaprapikey'];
                 }
                 echo '" alt="'.$link->link_name.'" width="'.$options['width'].'"/></a>';
                 if ($options['showdescription']!="" && $link->link_description != "") {
                          echo'<b class="wp-blogintroduction" >Beschreibung:</b><p class="wp-blogintroduction" >'.$link->link_description.'</p>';
                 }
                 ?>
                                 </div>
                                <!-- <form>
<input type="button" value="Test!" onclick="widget_blogintroductionRefreshLink();" />
</form>                          -->
<?php
?>
</ul>
<?php
                echo $after_widget;
        }

        register_sidebar_widget(array('Blogintroduction', 'widgets'), 'widget_blogintroduction');
        register_widget_control(array('Blogintroduction', 'widgets'), 'widget_blogintroduction_control',300,300);

}

add_action('widgets_init', 'widget_blogintroduction_init');
add_action('wp_head', 'widget_blogintroduction_js_header' );

function widget_blogintroduction_js_header()
{
         $options = (array) get_option('widget_blogintroduction');
         $refreshAfter == 0;
         if ($options['refreshviaAjax']!="" ) {
                 $refreshAfter = $options['refreshAfter'] * 1000;
         }

  // use JavaScript SACK library for Ajax
  wp_print_scripts( array( 'sack' ));

  // Defining custom JavaScript function
?>
<script type="text/javascript">
//<![CDATA[
function widget_blogintroductionRefreshLink() {
  var mysack = new sack(
       "<?php bloginfo( 'wpurl' ); ?>/wp-content/plugins/blogintroduction-wordpress-widget/blogintroduction_ajax.php" );

  mysack.execute = 1;
  mysack.method = 'POST';
  mysack.setVar( "link_div_id", "wp-blogintroduction-link" );
  mysack.onError = function() { alert('Ajax error in voting' )};
  mysack.runAJAX();
<?php
         if ($options['refreshviaAjax']!="" ) {?>
  setTimeout('widget_blogintroductionRefreshLink()', <?=$refreshAfter?> );
<?php
         } ?>
  return true;


}
<?php
         if ($options['refreshviaAjax']!="" ) {?>
setTimeout('widget_blogintroductionRefreshLink()', <?=$refreshAfter?> );
<?php
         } ?>
// end of JavaScript function widget_blogintroductionRefreshLink
//]]>
</script>
<?php
} // end of PHP function myplugin_js_header

?>